Index: issm/branches/trunk-jpl-damage/src/c/solutions/ProcessArguments.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/ProcessArguments.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/ProcessArguments.cpp	(revision 12878)
@@ -4,4 +4,6 @@
 
 #include <stdio.h>
+#include <cstring>
+
 #include "../shared/shared.h"
 #include "../include/include.h"
@@ -15,12 +17,12 @@
 	char *lockfilename   = NULL;
 
-	if(argc<2)_error_("Usage error: no solution requested");
+	if(argc<2)_error2_("Usage error: no solution requested");
 	*solution_type=StringToEnumx(argv[1]);
-	if(argc<3)_error_("Usage error: missing model name");
+	if(argc<3)_error2_("Usage error: missing model name");
 	modelname=argv[3];
-	binfilename    = (char*)xmalloc((strlen(modelname)+strlen(".bin")   +1)*sizeof(char)); sprintf(binfilename,   "%s%s",modelname,".bin");
-	outbinfilename = (char*)xmalloc((strlen(modelname)+strlen(".outbin")+1)*sizeof(char)); sprintf(outbinfilename,"%s%s",modelname,".outbin");
-	petscfilename  = (char*)xmalloc((strlen(modelname)+strlen(".petsc") +1)*sizeof(char)); sprintf(petscfilename, "%s%s",modelname,".petsc");
-	lockfilename   = (char*)xmalloc((strlen(modelname)+strlen(".lock")  +1)*sizeof(char)); sprintf(lockfilename,  "%s%s",modelname,".lock");
+	binfilename    = xNew<char>(strlen(modelname)+strlen(".bin")   +1); sprintf(binfilename,   "%s%s",modelname,".bin");
+	outbinfilename = xNew<char>(strlen(modelname)+strlen(".outbin")+1); sprintf(outbinfilename,"%s%s",modelname,".outbin");
+	petscfilename  = xNew<char>(strlen(modelname)+strlen(".petsc") +1); sprintf(petscfilename, "%s%s",modelname,".petsc");
+	lockfilename   = xNew<char>(strlen(modelname)+strlen(".lock")  +1); sprintf(lockfilename,  "%s%s",modelname,".lock");
 
 	/*Clean up and assign output pointer*/
Index: issm/branches/trunk-jpl-damage/src/c/solutions/ResetBoundaryConditions.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/ResetBoundaryConditions.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/ResetBoundaryConditions.cpp	(revision 12878)
@@ -3,5 +3,5 @@
  */ 
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../modules/modules.h"
 #include "../io/io.h"
@@ -15,5 +15,5 @@
 	int    i;
 
-	_printf_(VerboseSolution(),"%s\n","   updating boundary conditions...");
+	if(VerboseSolution()) _pprintLine_("   updating boundary conditions...");
 			
 	/*set current analysis: */
Index: issm/branches/trunk-jpl-damage/src/c/solutions/WriteLockFile.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/WriteLockFile.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/WriteLockFile.cpp	(revision 12878)
@@ -17,8 +17,8 @@
 	if(my_rank==0){
 		fid=fopen(filename,"w");
-		if(fid==NULL) _error_("%s%s","error message: could not open lock file ",filename);
+		if(fid==NULL) _error2_("error message: could not open lock file " << filename);
 
 		/*Close file: */
-		if(fclose(fid)!=0) _error_("%s%s","could not close lock file ",filename);
+		if(fclose(fid)!=0) _error2_("could not close lock file " << filename);
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/solutions/adjointbalancethickness_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/adjointbalancethickness_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/adjointbalancethickness_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -22,5 +22,5 @@
 
 	/*compute thickness */
-	_printf_(VerboseSolution(),"%s\n","   computing thickness");
+	if(VerboseSolution()) _pprintLine_("   computing thickness");
 	femmodel->SetCurrentConfiguration(BalancethicknessAnalysisEnum);
 	solver_linear(femmodel);
@@ -30,5 +30,5 @@
 
 	/*compute adjoint*/
-	_printf_(VerboseSolution(),"%s\n","   computing adjoint");
+	if(VerboseSolution()) _pprintLine_("   computing adjoint");
 	femmodel->SetCurrentConfiguration(BalancethicknessAnalysisEnum,AdjointBalancethicknessAnalysisEnum);
 	solver_adjoint_linear(femmodel);
@@ -36,5 +36,5 @@
 	/*Save results*/
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,AdjointEnum);
 	}
Index: issm/branches/trunk-jpl-damage/src/c/solutions/adjointdiagnostic_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/adjointdiagnostic_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/adjointdiagnostic_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -25,5 +25,5 @@
 
 	/*Compute velocities*/
-	_printf_(VerboseSolution(),"%s\n","   computing velocities");
+	if(VerboseSolution()) _pprintLine_("   computing velocities");
 	femmodel->SetCurrentConfiguration(DiagnosticHorizAnalysisEnum);
 	solver_nonlinear(femmodel,conserve_loads); 
@@ -33,5 +33,5 @@
 
 	/*Compute adjoint*/
-	_printf_(VerboseSolution(),"%s\n","   computing adjoint");
+	if(VerboseSolution()) _pprintLine_("   computing adjoint");
 	femmodel->SetCurrentConfiguration(DiagnosticHorizAnalysisEnum,AdjointHorizAnalysisEnum);
 	solver_adjoint_linear(femmodel);
@@ -39,5 +39,5 @@
 	/*Save results*/
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,AdjointxEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,AdjointyEnum);
Index: issm/branches/trunk-jpl-damage/src/c/solutions/balancethickness_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/balancethickness_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/balancethickness_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -24,9 +24,9 @@
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
 
-	_printf_(VerboseSolution(),"call computational core:\n");
+	if(VerboseSolution()) _pprintLine_("call computational core:");
 	solver_linear(femmodel);
 
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
 	}
Index: issm/branches/trunk-jpl-damage/src/c/solutions/bedslope_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/bedslope_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/bedslope_core.cpp	(revision 12878)
@@ -5,5 +5,5 @@
 #include "./solutions.h"
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -19,5 +19,5 @@
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
 
-	_printf_(VerboseSolution(),"%s\n","   computing slope");
+	if(VerboseSolution()) _pprintLine_("   computing slope");
 
 	/*Call on core computations: */
@@ -28,5 +28,5 @@
 	
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedSlopeXEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedSlopeYEnum);
Index: issm/branches/trunk-jpl-damage/src/c/solutions/control_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/control_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/control_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -20,5 +20,5 @@
 	int     num_controls,num_responses;
 	int     nsteps;
-	double  tol_cm;
+	IssmDouble  tol_cm;
 	bool    cm_gradient;
 	int     dim;
@@ -28,11 +28,11 @@
 
 	int*    control_type = NULL;
-	double* responses=NULL;
+	IssmDouble* responses=NULL;
 	int*    step_responses=NULL;
-	double* maxiter=NULL;
-	double* cm_jump=NULL;
+	IssmDouble* maxiter=NULL;
+	IssmDouble* cm_jump=NULL;
 		
 	/*intermediary: */
-	double  search_scalar=1;
+	IssmDouble  search_scalar=1;
 	OptArgs optargs;
 	OptPars optpars;
@@ -43,5 +43,5 @@
 
 	/*output: */
-	double* J=NULL;
+	IssmDouble* J=NULL;
 
 	/*Recover parameters used throughout the solution*/
@@ -66,10 +66,10 @@
 
 	/*Launch once a complete solution to set up all inputs*/
-	_printf_(VerboseControl(),"%s\n","   preparing initial solution");
+	if(VerboseControl()) _pprintLine_("   preparing initial solution");
 	if(isstokes) solutioncore(femmodel);
 
 	/*Initialize responses: */
-	J=(double*)xmalloc(nsteps*sizeof(double));
-	step_responses=(int*)xmalloc(num_responses*sizeof(int));
+	J=xNew<IssmDouble>(nsteps);
+	step_responses=xNew<int>(num_responses);
 		
 	/*Initialize some of the BrentSearch arguments: */
@@ -81,5 +81,5 @@
 
 		/*Display info*/
-		_printf_(VerboseControl(),"\n%s%i%s%i\n","   control method step ",n+1,"/",nsteps);
+		if(VerboseControl()) _pprintLine_("\n" << "   control method step " << n+1 << "/" << nsteps);
 		for(i=0;i<num_responses;i++) step_responses[i]=(int)responses[n*num_responses+i];
 		femmodel->parameters->SetParam(step_responses,1,num_responses,StepResponsesEnum);
@@ -88,5 +88,5 @@
 		if(solution_type==SteadystateSolutionEnum) solutioncore(femmodel);
 
-		_printf_(VerboseControl(),"%s\n","   compute adjoint state:");
+		if(VerboseControl()) _pprintLine_("   compute adjoint state:");
 		adjointcore(femmodel);
 		gradient_core(femmodel,n,search_scalar==0);
@@ -98,9 +98,9 @@
 		}
 
-		_printf_(VerboseControl(),"%s\n","   optimizing along gradient direction");
+		if(VerboseControl()) _pprintLine_("   optimizing along gradient direction");
 		optpars.maxiter=(int)maxiter[n]; optpars.cm_jump=cm_jump[n];
 		BrentSearch(&search_scalar,J+n,&optpars,&objectivefunction,&optargs);
 
-		_printf_(VerboseControl(),"%s\n","   updating parameter using optimized search scalar"); //true means update save controls
+		if(VerboseControl()) _pprintLine_("   updating parameter using optimized search scalar"); //true means update save controls
 		InputControlUpdatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,search_scalar,true);
 		
@@ -108,5 +108,5 @@
 	}
 
-	_printf_(VerboseControl(),"%s\n","   preparing final solution");
+	if(VerboseControl()) _pprintLine_("   preparing final solution");
 	femmodel->parameters->SetParam(true,SaveResultsEnum);
 	solutioncore(femmodel);
@@ -120,9 +120,9 @@
 	cleanup_and_return:
 	/*Free ressources: */
-	xfree((void**)&control_type);
-	xfree((void**)&responses);
-	xfree((void**)&step_responses);
-	xfree((void**)&maxiter);
-	xfree((void**)&cm_jump);
-	xfree((void**)&J);
+	xDelete<int>(control_type);
+	xDelete<int>(step_responses);
+	xDelete<IssmDouble>(maxiter);
+	xDelete<IssmDouble>(responses);
+	xDelete<IssmDouble>(cm_jump);
+	xDelete<IssmDouble>(J);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solutions/controlconvergence.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/controlconvergence.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/controlconvergence.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 #endif
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -17,5 +17,5 @@
 #include "./solutions.h"
 
-bool controlconvergence(double J, double tol_cm){
+bool controlconvergence(IssmDouble J, IssmDouble tol_cm){
 
 	int i;
@@ -23,7 +23,7 @@
 
 	/*Has convergence been reached?*/
-	if (!isnan(tol_cm) && J<tol_cm){
+	if (!xIsNan<IssmDouble>(tol_cm) && J<tol_cm){
 		converged=true;
-		_printf_(VerboseConvergence(),"      Convergence criterion reached: J = %g < %g",J,tol_cm);
+		if(VerboseConvergence()) _pprintString_("      Convergence criterion reached: J = " << J << " < " << tol_cm);
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/solutions/controlrestart.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/controlrestart.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/controlrestart.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 
-void controlrestart(FemModel* femmodel,double* J){
+void controlrestart(FemModel* femmodel,IssmDouble* J){
 
 	int      num_controls;
@@ -33,4 +33,4 @@
 
 	/*Clean up and return*/
-	xfree((void**)&control_type);
+	xDelete<int>(control_type);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solutions/controltao_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/controltao_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/controltao_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 #include <config.h>
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -17,5 +17,5 @@
 
 /*Local prototype*/
-int FormFunctionGradient(TaoSolver,Vec,double*,Vec,void*);
+int FormFunctionGradient(TaoSolver,Vec,IssmDouble*,Vec,void*);
 int IssmMonitor(TaoSolver,void*);
 typedef struct {
@@ -30,6 +30,6 @@
 	int        nsteps,maxiter;
 	AppCtx     user;
-	TaoSolver  tao;
-	double    *dummy          = NULL;
+	TaoSolver  tao = 0;
+	IssmDouble    *dummy          = NULL;
 	int       *control_list   = NULL;
 	Vector    *X              = NULL;
@@ -41,5 +41,5 @@
 	PetscGetArgs(&argc,&args);
 	ierr = TaoInitialize(&argc,&args,(char*)0,"");
-	if(ierr) _error_("Could not initialize Tao");
+	if(ierr) _error2_("Could not initialize Tao");
 
 	/*Recover some parameters*/
@@ -50,9 +50,9 @@
 	femmodel->parameters->FindParam(&dummy,NULL,NULL,InversionMaxiterPerStepEnum);
 	femmodel->parameters->SetParam(false,SaveResultsEnum);
-	maxiter=nsteps*(int)dummy[0]; xfree((void**)&dummy);
+	maxiter=nsteps*(int)dummy[0]; xDelete<IssmDouble>(dummy);
 
 	/*Initialize TAO*/
-	_printf_(VerboseControl(),"%s\n","   Initializing the Toolkit for Advanced Optimization (TAO)");
 	TaoCreate(PETSC_COMM_WORLD,&tao);
+	if(VerboseControl()) _pprintLine_("   Initializing the Toolkit for Advanced Optimization (TAO)");
 	TaoSetFromOptions(tao);
 	TaoSetType(tao,"tao_blmvm");
@@ -78,5 +78,5 @@
 
 	/*Solver optimization problem*/
-	_printf_(VerboseControl(),"%s\n","   Starting optimization");
+	if(VerboseControl()) _pprintLine_("   Starting optimization");
 	TaoSolve(tao);
 	TaoView(tao,PETSC_VIEWER_STDOUT_WORLD);
@@ -88,5 +88,5 @@
 
 	/*Finalize*/
-	_printf_(VerboseControl(),"%s\n","   preparing final solution");
+	if(VerboseControl()) _pprintLine_("   preparing final solution");
 	femmodel->parameters->SetParam(true,SaveResultsEnum);
 	void (*solutioncore)(FemModel*)=NULL;
@@ -95,10 +95,10 @@
 
 	/*Clean up and return*/
-	xfree((void**)&control_list);
+	xDelete<int>(control_list);
 	xdelete(&X);
 	TaoDestroy(&tao);
 	TaoFinalize();
 }
-int FormFunctionGradient(TaoSolver tao, Vec Xpetsc, double *fcn,Vec G,void *userCtx){
+int FormFunctionGradient(TaoSolver tao, Vec Xpetsc, IssmDouble *fcn,Vec G,void *userCtx){
 
 	/*Retreive arguments*/
@@ -107,5 +107,5 @@
 	FemModel *femmodel       = user->femmodel;
 	int      *cost_functions = NULL;
-	double   *cost_functionsd= NULL;
+	IssmDouble   *cost_functionsd= NULL;
 	Vector   *gradient       = NULL;
 	Vector   *X              = NULL;
@@ -125,5 +125,5 @@
 
 	/*Prepare objective function*/
-	cost_functions=(int*)xmalloc(num_cost_functions*sizeof(int));
+	cost_functions=xNew<int>(num_cost_functions);
 	for(int i=0;i<num_cost_functions;i++) cost_functions[i]=(int)cost_functionsd[i]; //FIXME
 	femmodel->parameters->SetParam(cost_functions,1,num_cost_functions,StepResponsesEnum);
@@ -146,6 +146,6 @@
 
 	/*Clean-up and return*/
-	xfree((void**)&cost_functions);
-	xfree((void**)&cost_functionsd);
+	xDelete<int>(cost_functions);
+	xDelete<IssmDouble>(cost_functionsd);
 	return 0;
 }
@@ -153,5 +153,5 @@
 
 	int       i,its,num_responses;
-	double    f,gnorm,cnorm,xdiff;
+	IssmDouble    f,gnorm,cnorm,xdiff;
 	AppCtx   *user      = (AppCtx *)userCtx;
 	FemModel *femmodel  = user->femmodel;
@@ -163,17 +163,17 @@
 
 	TaoGetSolutionStatus(tao, &its, &f, &gnorm, &cnorm, &xdiff, NULL);
-	if(its==0) _printf_(true,"Iter       Function      Residual  |  List of contributions\n");
-	if(its==0) _printf_(true,"-----------------------------------+-----------------------\n");
-	_printf_(true,"%4i   %12.7g  %12.7g  | ",its,f,gnorm);
+	if(its==0) _pprintLine_("Iter       Function      Residual  |  List of contributions");
+	if(its==0) _pprintLine_("-----------------------------------+-----------------------");
+	_pprintString_(setw(4)<<its<<"   "<<setw(12)<<setprecision(7)<<f<<"  "<<setw(12)<<setprecision(7)<<gnorm<<"  | ");
 
 	/*Retrieve objective functions independently*/
 	for(i=0;i<num_responses;i++){
 		Responsex(&f,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,EnumToStringx(responses[i]),false,i);
-		_printf_(true," %12.7g ","",f);
+		_pprintString_(" "<<setw(12)<<setprecision(7)<<f);
 	}
-	_printf_(true,"\n");
+	_pprintLine_("");
 
 	/*Clean-up and return*/
-	xfree((void**)&responses);
+	xDelete<int>(responses);
 	return 0;
 }
@@ -181,5 +181,5 @@
 #else
 void controltao_core(FemModel* femmodel){
-	_error_("TAO not installed or PETSc version not supported");
+	_error2_("TAO not installed or PETSc version not supported");
 }
 #endif //_HAVE_TAO_ 
Index: issm/branches/trunk-jpl-damage/src/c/solutions/convergence.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/convergence.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/convergence.cpp	(revision 12878)
@@ -3,5 +3,5 @@
  */ 
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../modules/modules.h"
 #include "../io/io.h"
@@ -19,15 +19,15 @@
 	Vector* KUoldF=NULL;
 	Vector* duf=NULL;
-	double ndu,nduinf,nu;
-	double nKUF;
-	double nKUoldF;
-	double nF;
-	double solver_residue,res;
+	IssmDouble ndu,nduinf,nu;
+	IssmDouble nKUF;
+	IssmDouble nKUoldF;
+	IssmDouble nF;
+	IssmDouble solver_residue,res;
 
 	/*convergence options*/
-	double eps_res;
-	double eps_rel;
-	double eps_abs;
-	double yts;
+	IssmDouble eps_res;
+	IssmDouble eps_rel;
+	IssmDouble eps_abs;
+	IssmDouble yts;
 
 	/*If uf is NULL in input, f-set is nil, model is fully constrained, therefore converged from 
@@ -55,5 +55,5 @@
 		nF=pf->Norm(NORM_TWO);
 		solver_residue=nKUF/nF;
-		_printf_(true,"\n%s%g\n","   solver residue: norm(KU-F)/norm(F)=",solver_residue);
+		_pprintLine_("\n" << "   solver residue: norm(KU-F)/norm(F)=" << solver_residue);
 
 		//clean up
@@ -70,7 +70,7 @@
 	nF=pf->Norm(NORM_TWO);
 	res=nKUoldF/nF;
-	if (isnan(res)){
-		_printf_(true,"norm nf = %lf and norm kuold = %lf\n",nF,nKUoldF);
-		_error_("mechanical equilibrium convergence criterion is NaN!");
+	if (xIsNan<IssmDouble>(res)){
+		_pprintLine_("norm nf = " << nF << "f and norm kuold = " << nKUoldF << "f");
+		_error2_("mechanical equilibrium convergence criterion is NaN!");
 	}
 
@@ -81,14 +81,14 @@
 	//print
 	if(res<eps_res){
-		_printf_(VerboseConvergence(),"%-50s%g%s%g%s\n","   mechanical equilibrium convergence criterion",res*100," < ",eps_res*100," %");
+		if(VerboseConvergence()) _pprintLine_(setw(50) << left << "   mechanical equilibrium convergence criterion" << res*100 << " < " << eps_res*100 << " %");
 		converged=true;
 	}
 	else{ 
-		_printf_(VerboseConvergence(),"%-50s%g%s%g%s\n","   mechanical equilibrium convergence criterion",res*100," > ",eps_res*100," %");
+		if(VerboseConvergence()) _pprintLine_(setw(50) << left << "   mechanical equilibrium convergence criterion" << res*100 << " > " << eps_res*100 << " %");
 		converged=false;
 	}
 
 	/*Relative criterion (optional)*/
-	if (!isnan(eps_rel) || (VerboseConvergence())){
+	if (!xIsNan<IssmDouble>(eps_rel) || (VerboseConvergence())){
 
 		//compute norm(du)/norm(u)
@@ -96,5 +96,5 @@
 		ndu=duf->Norm(NORM_TWO); nu=old_uf->Norm(NORM_TWO);
 
-		if (isnan(ndu) || isnan(nu)) _error_("convergence criterion is NaN!");
+		if (xIsNan<IssmDouble>(ndu) || xIsNan<IssmDouble>(nu)) _error2_("convergence criterion is NaN!");
 
 		//clean up
@@ -102,24 +102,24 @@
 
 		//print
-		if (!isnan(eps_rel)){
+		if (!xIsNan<IssmDouble>(eps_rel)){
 			if((ndu/nu)<eps_rel){
-				_printf_(VerboseConvergence(),"%-50s%g%s%g%s\n","   Convergence criterion: norm(du)/norm(u)",ndu/nu*100," < ",eps_rel*100," %");
+				if(VerboseConvergence()) _pprintLine_(setw(50) << left << "   Convergence criterion: norm(du)/norm(u)" << ndu/nu*100 << " < " << eps_rel*100 << " %");
 			}
 			else{ 
-				_printf_(VerboseConvergence(),"%-50s%g%s%g%s\n","   Convergence criterion: norm(du)/norm(u)",ndu/nu*100," > ",eps_rel*100," %");
+				if(VerboseConvergence()) _pprintLine_(setw(50) << left << "   Convergence criterion: norm(du)/norm(u)" << ndu/nu*100 << " > " << eps_rel*100 << " %");
 				converged=false;
 			}
 		}
-		else _printf_(true,"%-50s%g%s\n","   Convergence criterion: norm(du)/norm(u)",ndu/nu*100," %");
+		else _pprintLine_(setw(50) << left << "   Convergence criterion: norm(du)/norm(u)" << ndu/nu*100 << " %");
 
 	}
 
 	/*Absolute criterion (Optional) = max(du)*/
-	if (!isnan(eps_abs) || (VerboseConvergence())){
+	if (!xIsNan<IssmDouble>(eps_abs) || (VerboseConvergence())){
 
 		//compute max(du)
 		duf=old_uf->Duplicate(); old_uf->Copy(duf); duf->AYPX(uf,-1.0);
 		ndu=duf->Norm(NORM_TWO); nduinf=duf->Norm(NORM_INF);
-		if (isnan(ndu) || isnan(nu)) _error_("convergence criterion is NaN!");
+		if (xIsNan<IssmDouble>(ndu) || xIsNan<IssmDouble>(nu)) _error2_("convergence criterion is NaN!");
 
 		//clean up
@@ -127,14 +127,14 @@
 
 		//print
-		if (!isnan(eps_abs)){
+		if (!xIsNan<IssmDouble>(eps_abs)){
 			if ((nduinf*yts)<eps_abs){
-				_printf_(VerboseConvergence(),"%-50s%g%s%g%s\n","   Convergence criterion: max(du)",nduinf*yts," < ",eps_abs," m/yr");
+				if(VerboseConvergence()) _pprintLine_(setw(50) << left << "   Convergence criterion: max(du)" << nduinf*yts << " < " << eps_abs << " m/yr");
 			}
 			else{
-				_printf_(VerboseConvergence(),"%-50s%g%s%g%s\n","   Convergence criterion: max(du)",nduinf*yts," > ",eps_abs," m/yr");
+				if(VerboseConvergence()) _pprintLine_(setw(50) << left << "   Convergence criterion: max(du)" << nduinf*yts << " > " << eps_abs << " m/yr");
 				converged=false;
 			}
 		}
-		else  _printf_(true,"%-50s%g%s\n","   Convergence criterion: max(du)",nduinf*yts," m/yr");
+		else  _pprintLine_(setw(50) << left << "   Convergence criterion: max(du)" << nduinf*yts << " m/yr");
 
 	}
Index: issm/branches/trunk-jpl-damage/src/c/solutions/diagnostic_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/diagnostic_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/diagnostic_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -59,5 +59,5 @@
 	if(ishutter){
 			
-		_printf_(VerboseSolution(),"%s\n","   computing hutter velocities");
+		if(VerboseSolution()) _pprintLine_("   computing hutter velocities");
 
 		//Take the last velocity into account so that the velocity on the MacAyeal domain is not zero
@@ -72,5 +72,5 @@
 	if (ismacayealpattyn ^ isstokes){ // ^ = xor
 		
-		_printf_(VerboseSolution(),"%s\n","   computing velocities");
+		if(VerboseSolution()) _pprintLine_("   computing velocities");
 		femmodel->SetCurrentConfiguration(DiagnosticHorizAnalysisEnum);
 		if(isnewton)
@@ -82,5 +82,5 @@
 	if (ismacayealpattyn && isstokes){
 
-		_printf_(VerboseSolution(),"%s\n","   computing coupling macayealpattyn and stokes velocities and pressure ");
+		if(VerboseSolution()) _pprintLine_("   computing coupling macayealpattyn and stokes velocities and pressure ");
 		solver_stokescoupling_nonlinear(femmodel,conserve_loads);
 	}
@@ -88,5 +88,5 @@
 	if (dim==3 & (ishutter || ismacayealpattyn)){
 
-		_printf_(VerboseSolution(),"%s\n","   computing vertical velocities");
+		if(VerboseSolution()) _pprintLine_("   computing vertical velocities");
 		femmodel->SetCurrentConfiguration(DiagnosticVertAnalysisEnum);
 		solver_linear(femmodel);
@@ -95,5 +95,5 @@
 
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VyEnum);
@@ -105,4 +105,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&requested_outputs);
+	xDelete<int>(requested_outputs);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solutions/enthalpy_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/enthalpy_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/enthalpy_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -21,5 +21,5 @@
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
 
-	_printf_(VerboseSolution(),"   computing enthalpy\n");
+	if(VerboseSolution()) _pprintLine_("   computing enthalpy");
 	femmodel->SetCurrentConfiguration(EnthalpyAnalysisEnum);
 	solver_nonlinear(femmodel,true);
@@ -29,5 +29,5 @@
 
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,TemperatureEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,EnthalpyEnum);
Index: issm/branches/trunk-jpl-damage/src/c/solutions/gradient_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/gradient_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/gradient_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -16,6 +16,6 @@
 
 	/*Intermediaries*/
-	double  norm_inf;
-	double *norm_list    = NULL;
+	IssmDouble  norm_inf;
+	IssmDouble *norm_list    = NULL;
 	Vector*     new_gradient = NULL;
 	Vector*     gradient     = NULL;
@@ -23,9 +23,9 @@
 
 	/*Compute gradient*/
-	_printf_(VerboseControl(),"   compute cost function gradient\n");
+	if(VerboseControl()) _pprintLine_("   compute cost function gradient");
 	Gradjx(&gradient,&norm_list,femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters);
 
 	if (orthogonalize){
-		_printf_(VerboseControl(),"   orthogonalization\n");
+		if(VerboseControl()) _pprintLine_("   orthogonalization");
 		ControlInputGetGradientx(&old_gradient,femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters);
 		Orthx(&new_gradient,gradient,old_gradient); xdelete(&old_gradient); xdelete(&gradient);
@@ -37,6 +37,6 @@
 	/*Check that gradient is clean*/
 	norm_inf=new_gradient->Norm(NORM_INF);
-	if(norm_inf<=0)    _error_("||∂J/∂α||∞ = 0    gradient norm is zero");
-	if(isnan(norm_inf))_error_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
+	if(norm_inf<=0)    _error2_("||∂J/∂α||∞ = 0    gradient norm is zero");
+	if(xIsNan<IssmDouble>(norm_inf))_error2_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
 
 	/*plug back into inputs: */
@@ -48,4 +48,4 @@
 
 	/*Clean up and return*/
-	xfree((void**)&norm_list);
+	xDelete<IssmDouble>(norm_list);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solutions/hydrology_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/hydrology_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/hydrology_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -17,8 +17,8 @@
 
 	/*intermediary*/
-	double time;
+	IssmDouble time;
 	int    nsteps;
-	double starttime,final_time;
-	double dt;
+	IssmDouble starttime,final_time;
+	IssmDouble dt;
 	bool   save_results;
 	int    output_frequency;
@@ -45,5 +45,5 @@
 	for(i=0;i<nsteps;i++){
 		
-		if(nsteps)_printf_(VerboseSolution(),"time step:%i/%i\n",i+1,nsteps);
+		if(nsteps)if(VerboseSolution()) _pprintLine_("time step:" << i+1 << "/" << nsteps);
 		time+=dt;
 		femmodel->parameters->SetParam(time,TimeEnum);
@@ -53,5 +53,5 @@
 
 		if(save_results && ((i+1)%output_frequency==0 || (i+1)==nsteps)){
-			_printf_(VerboseSolution(),"   saving results \n");
+			if(VerboseSolution()) _pprintLine_("   saving results ");
 			//InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,WatercolumnEnum,i+1,time);
 			//InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,HydrologyWaterVxEnum,i+1,time);
@@ -59,5 +59,5 @@
 			
 			/*unload results*/
-			_printf_(VerboseSolution(),"   saving temporary results\n");
+			if(VerboseSolution()) _pprintLine_("   saving temporary results");
 			OutputResultsx(femmodel->elements, femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,femmodel->results);
 		}
